openapi: 3.0.2
info:
  title: Emergency RAVE controller
  description: REST API for the Emergency RAVE controller. See https://emergency-rave.gitlab.io/about-erave/
    for more information.
  version: 1.0.0
servers:
- url: /
paths:
  /treatmentparameters:
    summary: Path used to manage the list of treatmentparameters.
    description: The REST endpoint/path used to list and create zero or more `treatmentparameters`
      entities.  This path contains a `GET` and `POST` operation to perform the list
      and create tasks, respectively.
    get:
      summary: List All treatmentparameters
      description: Gets a list of all `treatmentparameters` entities.
      operationId: gettreatmentparameters2
      responses:
        "200":
          description: Successful response - returns an array of `treatmentparameters`
            entities.
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: '#/components/schemas/treatmentParameters'
                x-content-type: application/json
      x-openapi-router-controller: swagger_server.controllers.default_controller
    post:
      summary: Create a treatmentparameters
      description: Creates a new instance of a `treatmentparameters`.
      operationId: createtreatmentparameters
      requestBody:
        description: A new `treatmentparameters` to be created.
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/treatmentParameters'
        required: true
      responses:
        "201":
          description: Successful response.
      x-openapi-router-controller: swagger_server.controllers.default_controller
  /treatmentparameters/{treatmentparametersId}:
    summary: Path used to manage a single treatmentparameters.
    description: The REST endpoint/path used to get, update, and delete single instances
      of an `treatmentparameters`.  This path contains `GET`, `PUT`, and `DELETE`
      operations used to perform the get, update, and delete tasks, respectively.
    get:
      summary: Get a treatmentparameters
      description: Gets the details of a single instance of a `treatmentparameters`.
      operationId: gettreatmentparameters
      parameters:
      - name: treatmentparametersId
        in: path
        description: A unique identifier for a `treatmentparameters`.
        required: true
        style: simple
        explode: false
        schema:
          type: string
      responses:
        "200":
          description: Successful response - returns a single `treatmentparameters`.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/treatmentParameters'
      x-openapi-router-controller: swagger_server.controllers.default_controller
    put:
      summary: Update a treatmentparameters
      description: Updates an existing `treatmentparameters`.
      operationId: updatetreatmentparameters
      parameters:
      - name: treatmentparametersId
        in: path
        description: A unique identifier for a `treatmentparameters`.
        required: true
        style: simple
        explode: false
        schema:
          type: string
      requestBody:
        description: Updated `treatmentparameters` information.
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/treatmentParameters'
        required: true
      responses:
        "202":
          description: Successful response.
      x-openapi-router-controller: swagger_server.controllers.default_controller
    delete:
      summary: Delete a treatmentparameters
      description: Deletes an existing `treatmentparameters`.
      operationId: deletetreatmentparameters
      parameters:
      - name: treatmentparametersId
        in: path
        description: A unique identifier for a `treatmentparameters`.
        required: true
        style: simple
        explode: false
        schema:
          type: string
      responses:
        "204":
          description: Successful response.
      x-openapi-router-controller: swagger_server.controllers.default_controller
  /device-health:
    summary: Path used to manage the list of device-healths.
    description: The REST endpoint/path used to list and create zero or more `device-health`
      entities.  This path contains a `GET` and `POST` operation to perform the list
      and create tasks, respectively.
    get:
      summary: List All device-healths
      description: Gets a list of all `device-health` entities.
      operationId: getdevice_healths
      responses:
        "200":
          description: Successful response - returns an array of `device-health` entities.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/deviceHealth'
      x-openapi-router-controller: swagger_server.controllers.default_controller
    post:
      summary: Create a device-health
      description: Creates a new instance of a `device-health`.
      operationId: createdevice_health
      requestBody:
        description: A new `device-health` to be created.
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/deviceHealth'
        required: true
      responses:
        "201":
          description: Successful response.
      x-openapi-router-controller: swagger_server.controllers.default_controller
  /calibrationresults:
    summary: Path used to manage the list of calibrationresults.
    description: The REST endpoint/path used to list and create zero or more `calibrationresult`
      entities.  This path contains a `GET` and `POST` operation to perform the list
      and create tasks, respectively.
    get:
      summary: List All calibrationresults
      description: Gets a list of all `calibrationresult` entities.
      operationId: getcalibrationresults
      responses:
        "200":
          description: Successful response - returns an array of `calibrationresult`
            entities.
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: '#/components/schemas/calibrationResult'
                x-content-type: application/json
      x-openapi-router-controller: swagger_server.controllers.default_controller
    post:
      summary: Create a calibrationresult
      description: Creates a new instance of a `calibrationresult`.
      operationId: createcalibrationresult
      requestBody:
        description: A new `calibrationresult` to be created.
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/calibrationResult'
        required: true
      responses:
        "201":
          description: Successful response.
      x-openapi-router-controller: swagger_server.controllers.default_controller
  /calibrationresults/{calibrationresultId}:
    summary: Path used to manage a single calibrationresult.
    description: The REST endpoint/path used to get, update, and delete single instances
      of an `calibrationresult`.  This path contains `GET`, `PUT`, and `DELETE` operations
      used to perform the get, update, and delete tasks, respectively.
    get:
      summary: Get a calibrationresult
      description: Gets the details of a single instance of a `calibrationresult`.
      operationId: getcalibrationresult
      parameters:
      - name: calibrationresultId
        in: path
        description: A unique identifier for a `calibrationresult`.
        required: true
        style: simple
        explode: false
        schema:
          type: string
      responses:
        "200":
          description: Successful response - returns a single `calibrationresult`.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/calibrationResult'
      x-openapi-router-controller: swagger_server.controllers.default_controller
    put:
      summary: Update a calibrationresult
      description: Updates an existing `calibrationresult`.
      operationId: updatecalibrationresult
      parameters:
      - name: calibrationresultId
        in: path
        description: A unique identifier for a `calibrationresult`.
        required: true
        style: simple
        explode: false
        schema:
          type: string
      requestBody:
        description: Updated `calibrationresult` information.
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/calibrationResult'
        required: true
      responses:
        "202":
          description: Successful response.
      x-openapi-router-controller: swagger_server.controllers.default_controller
    delete:
      summary: Delete a calibrationresult
      description: Deletes an existing `calibrationresult`.
      operationId: deletecalibrationresult
      parameters:
      - name: calibrationresultId
        in: path
        description: A unique identifier for a `calibrationresult`.
        required: true
        style: simple
        explode: false
        schema:
          type: string
      responses:
        "204":
          description: Successful response.
      x-openapi-router-controller: swagger_server.controllers.default_controller
  /runtime-parameters:
    summary: Path used to manage the list of runtime-parameters.
    description: The REST endpoint/path used to list and create zero or more `runtime-parameters`
      entities.  This path contains a `GET` and `POST` operation to perform the list
      and create tasks, respectively.
    get:
      summary: List All runtime-parameters
      description: Gets a list of all `runtime-parameters` entities.
      operationId: getruntime_parameters
      responses:
        "200":
          description: Successful response - returns an array of `runtime-parameters`
            entities.
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: '#/components/schemas/runtimeParameters'
                x-content-type: application/json
      x-openapi-router-controller: swagger_server.controllers.default_controller
    post:
      summary: Create a runtime-parameters
      description: Creates a new instance of a `runtime-parameters`.
      operationId: createruntime_parameters
      requestBody:
        description: A new `runtime-parameters` to be created.
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/runtimeParameters'
        required: true
      responses:
        "201":
          description: Successful response.
      x-openapi-router-controller: swagger_server.controllers.default_controller
  /sensorreadings:
    summary: Path used to manage the list of sensorreadings.
    description: The REST endpoint/path used to list and create zero or more `sensorReadings`
      entities.  This path contains a `GET` and `POST` operation to perform the list
      and create tasks, respectively.
    get:
      summary: List All sensorreadings
      description: Gets a list of all `sensorReadings` entities.
      operationId: getsensorreadings
      responses:
        "200":
          description: Successful response - returns an array of `sensorReadings`
            entities.
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: '#/components/schemas/sensorReadings'
                x-content-type: application/json
      x-openapi-router-controller: swagger_server.controllers.default_controller
    post:
      summary: Create a sensorReadings
      description: Creates a new instance of a `sensorReadings`.
      operationId: createsensor_readings
      requestBody:
        description: A new `sensorReadings` to be created.
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/sensorReadings'
        required: true
      responses:
        "201":
          description: Successful response.
      x-openapi-router-controller: swagger_server.controllers.default_controller
  /sensorreadings/{sensorreadingsId}:
    summary: Path used to manage a single sensorReadings.
    description: The REST endpoint/path used to get, update, and delete single instances
      of an `sensorReadings`.  This path contains `GET`, `PUT`, and `DELETE` operations
      used to perform the get, update, and delete tasks, respectively.
    get:
      summary: Get a sensorReadings
      description: Gets the details of a single instance of a `sensorReadings`.
      operationId: getsensor_readings
      parameters:
      - name: sensorreadingsId
        in: path
        description: A unique identifier for a `sensorReadings`.
        required: true
        style: simple
        explode: false
        schema:
          type: string
      responses:
        "200":
          description: Successful response - returns a single `sensorReadings`.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/sensorReadings'
      x-openapi-router-controller: swagger_server.controllers.default_controller
    put:
      summary: Update a sensorReadings
      description: Updates an existing `sensorReadings`.
      operationId: updatesensor_readings
      parameters:
      - name: sensorreadingsId
        in: path
        description: A unique identifier for a `sensorReadings`.
        required: true
        style: simple
        explode: false
        schema:
          type: string
      requestBody:
        description: Updated `sensorReadings` information.
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/sensorReadings'
        required: true
      responses:
        "202":
          description: Successful response.
      x-openapi-router-controller: swagger_server.controllers.default_controller
    delete:
      summary: Delete a sensorReadings
      description: Deletes an existing `sensorReadings`.
      operationId: deletesensor_readings
      parameters:
      - name: sensorreadingsId
        in: path
        description: A unique identifier for a `sensorReadings`.
        required: true
        style: simple
        explode: false
        schema:
          type: string
      responses:
        "204":
          description: Successful response.
      x-openapi-router-controller: swagger_server.controllers.default_controller
components:
  schemas:
    sensorReadings:
      title: Root Type for sensorReadings
      type: object
      properties:
        timestamp:
          type: integer
          format: int32
        pressureMixChamber:
          type: integer
          format: int32
        airFlow:
          type: number
          format: double
        pressureLung:
          type: integer
          format: int32
        valveStatusIntervalSec:
          type: number
          format: double
        compressorValveOpenRatio:
          type: number
          format: double
        oxygenValveOpenRatio:
          type: number
          format: double
        inspirationValveOpenRatio:
          type: number
          format: double
        expirationValveOpenRatio:
          type: number
          format: double
      description: Sensor readings and valve status at a given time
      example:
        timestamp: 12345671234
        pressureMixChamber: 1200
        airFlow: 2.2
        pressureLung: 900
        valveStatusIntervalSec: 0.5
        compressorValveOpenRatio: 0.2
        oxygenValveOpenRatio: 0.01
        inspirationValveOpenRatio: 0.5
        expirationValveOpenRatio: 0.5
    runtimeParameters:
      title: Root Type for runtime-parameters
      type: object
      properties:
        oxygenPercent:
          type: integer
          description: |-
            percentage of oxygen
            allowed to flow inside the
            tank, when oxygen and air are mixed.
            Allowed values: 0-100
          format: int32
        respirationsPerMinute:
          type: integer
          description: |-
            frequency at which the patient breaths, in breathing cycles per minute. Allowed
            values: 6-17
          format: int32
        tankMaxPressure:
          type: integer
          description: "Upper end of the pressure range\nin the tank. If the pressure\
            \ is\nhigher than the limit, the\ncompressor turns off. \nAllowed values:\
            \ 0-14500"
          format: int32
        tankMinPressure:
          type: integer
          description: |-
            Lower end of pressure range
            in the tank. If the pressure is
            lower than the limit, the
            compressor turns on to refill
            the tank. Allowed values: 0-14500
          format: int32
        lungsMinPressure:
          type: integer
          description: |-
            Lower end of lung pressure range
            If the pressure is
            lower than the limit, the
            inspiration valve turns on
            after each period passes.
            Allowed values: 0-1600
          format: int32
        lungsMaxPressure:
          type: integer
          description: |-
            Upper end of lung pressure range.
            If the pressure is
            higher than the limit, the
            inspiration valve turns off
            after each period passes.
            Allowed values: 0-1600
          format: int32
        lungsCriticalPressure:
          type: integer
          description: 'Warning level for pressure in the lungs. Allowed values: 0-1600'
          format: int32
        operationsMode:
          type: string
          description: 'Operational Mode, one of "pressure", "time", "interactive". '
        inspirationTimePercent:
          type: integer
          description: "percentage of time that inspiration takes relative to the\
            \ length of the \nbreathing period. Range: 25-75"
          format: int32
        expirationTimePercent:
          type: integer
          description: "percentage of time that expiration takes relative to the length\
            \ of the \nbreathing period. Allowed range: 25-75"
          format: int32
        pressureUnit:
          type: string
          description: One of "mpsi", "pa", "cmh2o", "mmhg", "mbar"
        temperatureUnit:
          type: string
          description: One of "celsius", "farenheit"
      description: device runtime paramters for the controller
      example:
        oxygenPercent: 20
        respirationsPerMinute: 14
        tankMaxPressure: 12000
        tankMinPressure: 4500
        lungsMinPressure: 700
        lungsMaxPressure: 900
        lungsCriticalPressure: 950
        operationsMode: pressure
        inspirationTimePercent: 50
        expirationTimePercent: 50
        pressureUnit: mbar
        temperatureUnit: celsius
    deviceHealth:
      title: Root Type for device-health
      type: object
      properties:
        status:
          type: string
        issues:
          type: array
          items:
            $ref: '#/components/schemas/deviceHealth_issues'
      description: device health information
      example:
        status: ok
        issues:
        - timestamp: 1234567123
          message: no data from sensor p1
          count: 3
          severety: error
        - timestamp: 1234567125
          message: sensor p1 back to normal
          count: 1
          severety: info
    calibrationResult:
      title: Root Type for calibrationresult
      type: object
      properties:
        venturi-system-const:
          type: integer
          format: int32
        compressor-mbar-max:
          type: integer
          format: int32
        flow-ml-sec-max:
          type: integer
          format: int32
      description: Results of system calibration
      example:
        venturi-system-const: 1
        compressor-mbar-max: 50
        flow-ml-sec-max: 2
    treatmentParameters:
      title: Root Type for treatmentparameters
      type: object
      properties:
        pressure:
          type: number
          description: required lung pressure in mbar
          format: float
        frequency:
          type: number
          description: breath cycles per second
          format: float
        flow:
          type: number
          description: moved gas volume per breath cycle in ml
          format: float
        lung-tidal-vol:
          type: number
          description: tidal volume (TV) of lung in ml
          format: float
        lung-inspiratory-reserve-vol:
          type: number
          description: inspiratory reserve volume (IRV) of lung in ml
          format: float
        lung-expiratory-reserve-vol:
          type: number
          description: expiratory reserve volume (ERV) of lung in ml
          format: float
        lung-residual-vol:
          type: number
          description: residual volume (RV) of lung in ml
          format: float
      description: Runtime parameters set by the caregiver
      example:
        pressure: 9.2
        frequency: 0.4
        flow: 500
        lung-tidal-vol: 500
        lung-inspiratory-reserve-vol: 2500
        lung-expiratory-reserve-vol: 1500
        lung-residual-vol: 1500
    deviceHealth_issues:
      type: object
      properties:
        timestamp:
          type: integer
          format: int32
        message:
          type: string
        count:
          type: integer
          format: int32
        severety:
          type: string
  responses:
    sensorReading:
      description: Returns the current sensor readings
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/sensorReadings'
    deviceHealth:
      description: Device health information, including warnings and error messages
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/deviceHealth'
    calibrationResult:
      description: Result of a device calibration run
    runtimeParameters:
      description: Parameters for normal operation. Can be set instead of treatment
        parameters for more control by the caregiver
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/runtimeParameters'
    treatmentParameters:
      description: simplified variant of runtime parameters
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/treatmentParameters'

